import java.io.*;
import java.util.Scanner;
import java.util.Random;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Formatter;
import java.util.Collections;
import java.text.DecimalFormat; 
 
class CondorceyS {

static Scanner keyb = new Scanner(System.in);

    public static void main(String[] args) {

		System.out.println("");System.out.println(""); System.out.println("       * * *   CONDORCEY   * * *"); System.out.println("");
		
		ArrayList<Prop> CollProp = new ArrayList<Prop>();
		int NbProp=0;
		
		String mode = "";
		if(args.length>0){mode=args[0];}
		else {
			System.out.println("Quel mode ? (m : manuel   -   t : tabulation   -   p : point-virgule  -  v : virgule    -    nom du fichier csv(virgule) )");
			mode = keyb.nextLine();}
		
	if(!mode.equals("m")){

		System.out.println("");
		
		String delimiter = "";
		
	if(mode.length()==1){
		if(mode.equals("t")){delimiter="\\t";}
		else if(mode.equals("p")){delimiter=";";}
		else if(mode.equals("v")){delimiter=",";}
		else{delimiter=mode;}
		
		System.out.println("Copiez-collez selon le modèle : ");
		String suitCand = keyb.nextLine();
		
		String[] Cand = suitCand.split(delimiter);
		NbProp = Cand.length-1;
		for(int i=1 ; i<Cand.length ; ++i){
			CollProp.add(new Prop(NbProp, i-1, Cand[i]));
			}
		
		ArrayList<Double> curNotes = new ArrayList<Double>();		
		boolean Voting =true;
		
		while(Voting){									
			String curVote=keyb.nextLine();
			String[] curVotes = curVote.split(delimiter);
			for(int i=1;i<curVotes.length && i<NbProp+1;++i){curNotes.add(Double.parseDouble(curVotes[i]));}
			
			if(curNotes.size()>0){
				for(int i=0; i<NbProp; ++i){				
					double curNote=curNotes.get(i);
					if(curNote<1){curNote=1;}
					if(curNote>100){curNote=100;}
					for(int j=0; j<i;++j){
						if(curNotes.get(j)<curNote){
							CollProp.get(j).VoteW(i);
							CollProp.get(i).VoteL(j);						
							}
						if(curNotes.get(j)>curNote){
							CollProp.get(j).VoteL(i);
							CollProp.get(i).VoteW(j);						
							}	
						}
					CollProp.get(i).addNote(curNote);				
				}										
			}
			else{Voting=false;}
			curNotes = new ArrayList<Double>();		
		}
	}
	else{
		try{
		InputStream ips=new FileInputStream(mode); 
		InputStreamReader ipsr=new InputStreamReader(ips);
		BufferedReader br=new BufferedReader(ipsr);
		
		String suitCand = br.readLine();		
		String[] Cand = suitCand.split(",");
		NbProp = Cand.length-1;
		for(int i=1 ; i<Cand.length ; ++i){
			CollProp.add(new Prop(NbProp, i-1, Cand[i]));
			}
		ArrayList<Double> curNotes = new ArrayList<Double>();					
		boolean Voting =true;
		String curVote="";
		while(Voting && (curVote=br.readLine())!=null){									
			String[] curVotes = curVote.split(",");
			for(int i=1;i<curVotes.length && i<NbProp+1;++i){curNotes.add(Double.parseDouble(curVotes[i]));}
			
			if(curNotes.size()>0){
				for(int i=0; i<NbProp; ++i){				
					double curNote=curNotes.get(i);
					if(curNote<1){curNote=1;}
					if(curNote>100){curNote=100;}
					for(int j=0; j<i;++j){
						if(curNotes.get(j)<curNote){
							CollProp.get(j).VoteW(i);
							CollProp.get(i).VoteL(j);						
							}
						if(curNotes.get(j)>curNote){
							CollProp.get(j).VoteL(i);
							CollProp.get(i).VoteW(j);						
							}	
						}
					CollProp.get(i).addNote(curNote);				
				}										
			}
			else{Voting=false;}
			curNotes = new ArrayList<Double>();		
		}
		br.close();}
		catch (Exception e){
			System.out.println(e.toString());
		}
		}
		

	}
	
	else{
		
		NbProp=0;
		int NbPop=0;		
				
		System.out.println("");System.out.println("Nombre de candidats / propositions ?");
		NbProp=keyb.nextInt();
		keyb.nextLine();		
		for(int i=0 ; i<NbProp ; ++i){
			System.out.println("");
			System.out.println("Nom du candidat n°"+(char)(i+65)+" ?   ("+(i+1)+" / "+NbProp+" )");
			CollProp.add(new Prop(NbProp, i, keyb.nextLine()));
		}

		boolean Voting = true;
		while(Voting){
			NbPop=NbPop+1;
			ArrayList<Double> CurNotes = new ArrayList<Double>();
			System.out.println("");	System.out.println("");
			System.out.println("       Votons !");	System.out.println("");

			for(int i=0; i<NbProp; ++i){
				System.out.println("");
				System.out.println("Votant n° "+NbPop+" ;");
				System.out.println("Quel rang (1=Best, 100=Beurk) attribuez-vous au candidat *** "+(char)(i+65)+" : "+CollProp.get(i).getName()+" *** ?");
				double curNote=keyb.nextDouble();
				if(curNote<1){curNote=1;}
				if(curNote>100){curNote=100;}
				for(int j=0; j<CurNotes.size();++j){
					if(CurNotes.get(j)<curNote){
						CollProp.get(j).VoteW(i);
						CollProp.get(i).VoteL(j);						
						}
					if(CurNotes.get(j)>curNote){
						CollProp.get(j).VoteL(i);
						CollProp.get(i).VoteW(j);						
						}	
					}
				CollProp.get(i).addNote(curNote);
				CurNotes.add(curNote);
			}
			System.out.println("");
			System.out.println("Merci votant n°"+NbPop+" !");
			System.out.println("");
			System.out.println("");
			System.out.println("Tout le monde a voté ? (0 si oui, 1 pour continuer à voter)");
			if(keyb.nextInt()==0){Voting = false;}							
		}
	}
		
		ArrayList<Prop> WinningProp = new ArrayList<Prop>();
		CollProp.get(0).makeScores();
		WinningProp.add(CollProp.get(0));
		for (int i=1; i<NbProp; ++i){
			Prop curProp = CollProp.get(i);
			curProp.makeScores();
			if(curProp.getVD()==WinningProp.get(0).getVD()){
				WinningProp.add(curProp);}
			if(curProp.getVD()>WinningProp.get(0).getVD()){
				WinningProp = new ArrayList<Prop>();
				WinningProp.add(curProp);}
			
			}
		if(WinningProp.get(0).getV()==(NbProp-1)){
			Prop Winner = WinningProp.get(0);
			System.out.println("");
			System.out.println("");
			System.out.println("       Il y a un vainqueur de Condorcet ! ");
			System.out.println("");
			System.out.println("       * * *   n° "+(char)(Winner.getId()+65)+" : "+Winner.getName()+"   * * *"); 
			System.out.println("");
			}

		else{
			System.out.println("");
			System.out.println("");
			System.out.println("Il n'y a pas de vainqueur de Condorcet...");
			
			Integer curSize=2;				
			CleSuSets A= new CleSuSets(curSize);
			boolean Searching =true;
			while(Searching){
				A= new CleSuSets(curSize);			
				boolean subSearching=true;
				while(subSearching){
					ArrayList<Integer> curTest = A.getSS();
					ArrayList<Integer> curComp = A.getCS(NbProp);
					int siC=curComp.size();
					int i=0;
					boolean stillValid=true; 
					while(stillValid && i<curSize){
						stillValid = CollProp.get(curTest.get(i)).cardAllB(siC);
						++i;
						}
					if(stillValid){
						i=0;
						while(stillValid && i<curSize){
							stillValid = CollProp.get(curTest.get(i)).allBeaten(curComp);
//							System.out.println(stillValid+" - "+curTest.get(i));
//							System.out.println(curTest.get(i)+" - "+stillValid);
							++i;
							}
						}
					
					if(stillValid){Searching=false;subSearching=false;}				
					else{subSearching=A.increment(0,NbProp-1);}
					}
				if(Searching){++curSize;}			
				}			
			
			ArrayList<Integer> gpeTete = A.getSS();
			
			WinningProp = new ArrayList<Prop>();
			for(int i=0;i<gpeTete.size();++i){WinningProp.add(CollProp.get(gpeTete.get(i)));}
			
				
			double min=WinningProp.get(0).getMediane();
			System.out.println("");
			System.out.println("Le candidat n° "+(char)(WinningProp.get(0).getId()+65)+" ("+WinningProp.get(0 ).getName()+") a une médiane à "+min+" ;");						
			for(int i=1; i<WinningProp.size() ;++i){
				double tmp=WinningProp.get(i).getMediane();
				System.out.println("Le candidat n° "+(char)(WinningProp.get(i).getId()+65)+" ("+WinningProp.get(i).getName()+") a une médiane à "+tmp+" ;");
				if(tmp<min){min=tmp;}
				}										

			System.out.println("");
			System.out.println("       C'est donc le candidat :");System.out.println("");
			for(int i=0; i<WinningProp.size();++i){
				if(WinningProp.get(i).getMediane()==min){
				System.out.println("       n° "+(char)(WinningProp.get(i).getId()+65)+" :  * * *   "+WinningProp.get(i).getName()+"   * * *");
					}								
				}
			System.out.println("");
			System.out.println("       qui a la meilleure médiane du groupe de tête."); System.out.println("");													
			
			}			
		
		String end=keyb.nextLine(); end=keyb.nextLine(); 
		System.out.println(end);

		}
}


class CleSuSets {
	protected ArrayList<Integer> SubSet;
	int size;
	
	public CleSuSets(int s){
		this.SubSet = new ArrayList<Integer>();
		this.size= s;
		for(int i=0;i<s;++i){
			SubSet.add(size-i-1);
			}
		}
	
	public ArrayList<Integer> getSS(){
		return SubSet;
		}



	public ArrayList<Integer> getCS(int NbP){
		ArrayList<Integer> CompSet = new ArrayList<Integer>();
		for(int i=0;i<NbP;i=i+1){
			boolean nouvN = true;
			for(int j=0;j<SubSet.size();++j){				
				if(SubSet.get(j)==i){nouvN=false;}
				}
			if(nouvN){CompSet.add(i);}
			}
		return CompSet;
		}	


	
	public boolean increment(int i, int m){
		if(SubSet.get(i)<m){SubSet.set(i,SubSet.get(i)+1); return true;}
		else if(i<size-1){
			boolean b=increment(i+1, m-1);
			SubSet.set(i,SubSet.get(i+1)+1);
			return b;}
		else {return false;}		
		}

	
	public void affiche(){
		String str="";
		for(int i=0;i<size;++i){
			str=str+SubSet.get(i);
			}
		System.out.println(str);
		str=" - - ";
		ArrayList<Integer> CompSet=this.getCS(5);
		for(int i=0;i<CompSet.size();++i){
			str=str+CompSet.get(i);
			}
		System.out.println(str);		
		}
	
}


class Prop {
	protected String Name;
	protected int NuId;
	protected ArrayList<Integer> TotVoteW;
	protected ArrayList<Integer> TotVoteL;
	protected ArrayList<Double> Notes;
	protected int NbVict;
	protected int NbDeuce;
	protected int NbVD;
	protected ArrayList<Integer> CandBattus;
	protected ArrayList<Integer> CandDeuce;
	
	public int getId(){return NuId;}
	public int getV(){return NbVict;}
	public int getD(){return NbDeuce;}		
	public int getVD(){return NbVD;}
	public String getName(){return Name;}
	public ArrayList<Integer> getBattus(){return CandBattus;}
	public ArrayList<Integer> getDeuce(){return CandDeuce;}
	
	public void VoteW(int Opponent){TotVoteW.set(Opponent, TotVoteW.get(Opponent)+1);}
	public void VoteL(int Opponent){TotVoteL.set(Opponent, TotVoteL.get(Opponent)+1);}
	public double getMediane(){Collections.sort(Notes);return Notes.get(Notes.size()/2);}
	public void addNote(double Note){Notes.add(Note);}


	public boolean cardAllB(int siComp){
		return (CandBattus.size()>=siComp);
		}
	
	public boolean allBeaten(ArrayList<Integer> compSet){
		int i=0;
		int j=0;
		int iMax=compSet.size();
		int jMax=CandBattus.size();
//		System.out.println(Name);
		while(i<iMax && j<jMax){			
			int cI=compSet.get(i);
			int cJ=CandBattus.get(j);
//			System.out.println("iMax-"+iMax+" ; i-"+cI+" ; j-"+cJ);
			if(cI==cJ){++i;++j;}
			else if(cJ<cI){++j;}
			else{return false;}
			}
		if(i>=iMax){return true;}		
		return false;		
		}
		
	public void makeScores(){
		NbVict = 0;
		NbDeuce = 0;
		String sB="Le candidat n°"+(char)(NuId+65)+" ("+Name+") bat les n°: ";
		String sD="   et fait égalité avec les n°: ";
		for(int i=0;i<TotVoteW.size();++i){
			if (i==NuId){}
			else {
				if (TotVoteW.get(i)>TotVoteL.get(i)){
					NbVict=NbVict+1; 
					CandBattus.add(i);
					sB=sB+(char)(i+65)+" (";
					int rate = (TotVoteW.get(i))*100/(TotVoteW.get(i)+TotVoteL.get(i));
					sB=sB+rate+" %) , ";
					}
				if (TotVoteW.get(i)==TotVoteL.get(i)){NbDeuce=NbDeuce+1; CandDeuce.add(i);sD=sD+(char)(i+65)+" , ";}
			}
		}
		System.out.println("");		System.out.println("");
		System.out.println(sB);
		if(NbDeuce>0){System.out.println(sD);}
		NbVD=2*NbVict+NbDeuce;
	}



	public Prop(int NbProp, int Id, String Nom){
		this.NuId = Id;
		this.Name = Nom;
		this.TotVoteW = new ArrayList<Integer>(NbProp);
		this.TotVoteL = new ArrayList<Integer>(NbProp);
		for(int i=0;i<NbProp;++i){TotVoteL.add(0);TotVoteW.add(0);}
		this.Notes = new ArrayList<Double>();
		this.CandBattus = new ArrayList<Integer>();
		this.CandDeuce = new ArrayList<Integer>();
		this.NbVict=0;
		this.NbDeuce=0;
		this.NbVD=0;
		}
	}	 


